package cn.jtkj.pushserver.util.fileEncryptUtil;

import cn.jtkj.pushserver.entity.BindingCardInfoPushEntity;
import cn.jtkj.pushserver.util.fileEncryptUtil.RSAUtils;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.security.PublicKey;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.net.ftp.FTPClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FileEncryptor {

   private static Logger logger = LoggerFactory.getLogger(FileEncryptor.class);
   private static final String PRIVATE_KEY_PATH = "private.key";
   private static final String PUBLICE_KEY_PATH = "public.key";
   private static final String ftpHost = "220.200.155.4";
   private static final int ftpPort = 21;
   private static final String ftpUser = "ftp-user2";
   private static final String ftpPassword = "123456";
   private static final String ftpRemotePath = "/home/vsftpd/ftp-user2/";


   public static List encrypt() throws Exception {
      ArrayList list = new ArrayList();
      HashMap objectObjectHashMap = new HashMap();
      objectObjectHashMap.put("id", "52545");
      objectObjectHashMap.put("name", "张收到罚单三");
      objectObjectHashMap.put("age", "18");
      HashMap objectObjectHashMap2 = new HashMap();
      objectObjectHashMap2.put("id", "36985");
      objectObjectHashMap2.put("name", "张受到广泛豆腐干三");
      objectObjectHashMap2.put("age", "22");
      HashMap objectObjectHashMap3 = new HashMap();
      objectObjectHashMap3.put("id", "45678");
      objectObjectHashMap3.put("name", "的方法撒旦发个");
      objectObjectHashMap3.put("age", "42");
      HashMap objectObjectHashMap4 = new HashMap();
      objectObjectHashMap4.put("id", "13");
      objectObjectHashMap4.put("name", "Bert不容改变风格");
      objectObjectHashMap4.put("age", "74587");
      HashMap objectObjectHashMap5 = new HashMap();
      objectObjectHashMap5.put("id", "12454");
      objectObjectHashMap5.put("name", "现场v白色如果");
      objectObjectHashMap5.put("age", "34");
      list.add(objectObjectHashMap);
      list.add(objectObjectHashMap2);
      list.add(objectObjectHashMap3);
      list.add(objectObjectHashMap4);
      list.add(objectObjectHashMap5);
      return list;
   }

   public static byte[] encryptData(List data, PublicKey publicKey) throws Exception {
      StringBuilder dataStr = new StringBuilder();
      Iterator var3 = data.iterator();

      while(var3.hasNext()) {
         BindingCardInfoPushEntity item = (BindingCardInfoPushEntity)var3.next();
         dataStr.append(item.getType().toString()).append("|").append(item.getVehicleId().toString()).append("|").append(item.getVehicleColor().toString()).append("|").append(item.getAccountId().toString()).append("|").append(item.getBankUserName().toString()).append("|").append(item.getCertsn().toString()).append("|").append(item.getLinkMobile().toString()).append("|").append(item.getUpdateTime().toString()).append("|");
         if(dataStr.length() > 0) {
            dataStr.setLength(dataStr.length() - 1);
            dataStr.append(System.lineSeparator());
         }
      }

      logger.info(dataStr.toString());
      return RSAUtils.encrypt(dataStr.toString().getBytes(), publicKey);
   }

   public static void uploadToFtp(String server, int port, String user, String pass, String remotePath, byte[] encryptedData) throws IOException {
      FTPClient ftpClient = new FTPClient();

      try {
         ftpClient.connect(server, port);
         ftpClient.login(user, pass);
         ftpClient.enterLocalPassiveMode();
         ftpClient.setFileType(2);
         boolean done = ftpClient.storeFile(remotePath, new ByteArrayInputStream(encryptedData));
         if(done) {
            System.out.println("文件上传成功: " + remotePath);
         } else {
            System.out.println("文件上传失败: " + remotePath);
         }
      } finally {
         ftpClient.logout();
         ftpClient.disconnect();
      }

   }

   public static void main(String[] args) {
   }

   public static void extracted(String fileName, List data) {
      try {
         PublicKey e;
         try {
            e = RSAUtils.loadPublicKey("public.key");
         } catch (Exception var4) {
            logger.info("配置文件未读取到密钥{}", "public.key");
            throw new RuntimeException("Failed to load public key from file.", var4);
         }

         logger.info("公钥{}", e);
         byte[] encryptedData = encryptData(data, e);
         uploadToFtp("220.200.155.4", 21, "ftp-user2", "123456", "/home/vsftpd/ftp-user2/" + fileName, encryptedData);
         System.out.println("文件已上传到 FTP 服务器。");
      } catch (Exception var5) {
         var5.printStackTrace();
      }

   }

}
